/*******************************************************************************
 * Copyright (c) 2014-2015 Marian Schedenig
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Marian Schedenig - initial API and implementation
 *******************************************************************************/

package name.schedenig.eclipse.clippets.c.tags;

import name.schedenig.eclipse.clippets.c.utils.CUtils;
import name.schedenig.eclipse.clippets.livetags.ILiveTag;

import org.eclipse.cdt.core.model.IFunction;
import org.eclipse.cdt.core.model.IMethod;
import org.eclipse.ui.texteditor.ITextEditor;

public class CMethodLiveTag implements ILiveTag
{
	public String resolveTag(ITextEditor editor, java.util.List<String> params)
	{
		IMethod method = CUtils.getCMethod(editor);
		
		if(method != null)
		{
			return method.getElementName();
		}
		
		IFunction function = CUtils.getCFunction(editor);
		
		if(function != null)
		{
			return function.getElementName();
		}
		return null;
	}
}
