/*******************************************************************************
 * Copyright (c) 2014-2015 Marian Schedenig
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Marian Schedenig - initial API and implementation
 *******************************************************************************/

package name.schedenig.eclipse.clippets.c.tags;

import name.schedenig.eclipse.clippets.c.utils.CUtils;
import name.schedenig.eclipse.clippets.livetags.ILiveTag;

import org.eclipse.cdt.core.model.ICElement;
import org.eclipse.cdt.core.model.IMethod;
import org.eclipse.cdt.core.model.IStructure;
import org.eclipse.ui.texteditor.ITextEditor;

public class CTypeLiveTag implements ILiveTag
{
	public String resolveTag(ITextEditor editor, java.util.List<String> params)
	{
		IStructure structure = CUtils.getCStructure(editor, ICElement.C_CLASS);
		
		if(structure == null)
		{
			structure = CUtils.getCStructure(editor, ICElement.C_STRUCT);
		}
		
		if(structure != null)
		{
			return structure.getElementName();
		}
		
		IMethod method = CUtils.getCMethod(editor);
		
		if(method == null)
		{
			return null;
		}
		
		String name = method.getElementName();
		int i = name.lastIndexOf("::"); //$NON-NLS-1$
		
		if(i < 0)
		{
			return null;
		}
		
		name = name.substring(0, i);
		return name;
	}
}
